/* 
   ORSA - Orbit Reconstruction, Simulation and Analysis
   Copyright (C) 2002-2004 Pasquale Tricarico
   
   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   As a special exception, Pasquale Tricarico gives permission to
   link this program with Qt commercial edition, and distribute the
   resulting executable, without including the source code for the Qt
   commercial edition in the source distribution.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _XORSA_OBJECT_SELECTOR_H_
#define _XORSA_OBJECT_SELECTOR_H_

#include <vector>
#include <map>

#include <qlistview.h>
#include <qdialog.h> 

class QPushButton;
class QListViewItem;

#include <orsa_body.h>

class XOrsaObjectSelector : public QDialog {
  
  Q_OBJECT
  
 public:
  XOrsaObjectSelector(std::vector<orsa::BodyWithEpoch>&, bool only_massive=false, QWidget *parent=0);
  
 private slots:
  void ok_pressed();
  void cancel_pressed();
  void fill_listview();
  void slot_enable_ok_button();
  
 private:
  void common_init();
  
 public:
  QListView *listview;
  
 private:
  QPushButton *okpb;
  QPushButton *cancpb; 
  
 private:
  std::vector<orsa::BodyWithEpoch> &list; 
  //
  const bool only_massive_objects;
  
 public:
  orsa::BodyWithEpoch body_selected;
  
  std::map < QListViewItem* ,std::vector<orsa::BodyWithEpoch>::iterator > body_map_it;
  
 public:
  bool ok; // wheter the ok button has been pressed
};

#endif // _XORSA_OBJECT_SELECTOR_H_
